//------------------------------------------------------------------------------
//  DoubleClass.cpp -   , 
//   .
//------------------------------------------------------------------------------

#include <iostream>
using namespace std;

#include "IntClass.h"
#include "DoubleClass.h"

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//     .   -  
//    
Number* Double::Subtract(Number& num2)
{
    if(Int* pInt = dynamic_cast<Int*>(&num2))
	{
		//   -  .    
		//     RTTI.
		return new Double(_value - pInt->GetValue()); 
	}
    else if(Double* pDouble = dynamic_cast<Double*>(&num2))
	{
		//   -  .    
		//     RTTI.
		//    
		return new Double(_value - pDouble->GetValue()); 
	}
	else
	{
		//  ,    
		// .      
		//     Double
		//      .
		return num2.SubtFrom(*this);
	}
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  ,     
//  ,   ,   .
//      .
//  ,     RTTI,   
//   
Number* Double::SubtFrom(Number& num1)
{
    if(Int* pInt = dynamic_cast<Int*>(&num1))
	{
		//   -  .    
		//     RTTI.
		//    
		return new Double(pInt->GetValue() - _value); 
	}
	else
	{
		return 0;
	}
	// ,      .
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//      
void Double::StdOut()
{
	cout << "It is Double. Value = " << _value << endl;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// ,   .
Double::Double(double v): _value(v)
{}
